% Function to compute Arithmetic Asian Option price ; Using Financial
% Tooolbox functions
%
% See article "Approaches to implementing Monte Carlo methods in MATLAB"
% by Sri Krishnamurthy,CFA and Jorge Paloschi,PHD
% in the September 2011 article of Wimott Magazine or at
% http://www.wilmott.com/magazine.cfm 
%
% Copyright 2011 MathWorks, Inc.
function [Price] = PriceArithmeticAsianOptionFin(S0,X,r,T,sigma,NSteps,NPaths)
dt=T/NSteps;
RetSeries = squeeze(portsim(r, sigma^2, NSteps,dt, NPaths, 'Expected'));
Path = ret2tick(RetSeries, repmat(S0, 1, NPaths))';
% Pre-allocate the grid
DiscPayoff=zeros(1,NPaths);

for i=1:NPaths
DiscPayoff(i) = exp(-r*T) .* max(sum(Path(i,2:end))./NSteps - X,0); 
end
Price = mean(DiscPayoff);
