% Function to compute Arithmetic Asian Option price ; Using SDE and
% Antithetic sampling
%
% See article "Approaches to implementing Monte Carlo methods in MATLAB"
% by Sri Krishnamurthy,CFA and Jorge Paloschi,PHD
% in the September 2011 article of Wimott Magazine or at
% http://www.wilmott.com/magazine.cfm 
%
% Copyright 2011 MathWorks, Inc.
function [Price Var] = PriceArithmeticAsianOptionSDEAntiThetic(S0,X,r,T,sigma,NSteps,NPaths)
dt=T/NSteps;

test = gbm(r,sigma);
Path = S0*squeeze(test.simByEuler(NSteps, 'DeltaTime', dt, 'nTrials', NPaths,'Antithetic',true))';

% Pre-allocate the grid
DiscPayoff=zeros(1,NPaths);

for i=1:NPaths
DiscPayoff(i) = exp(-r*T) .* max(sum(Path(i,2:end))./NSteps - X,0); 
end
[Price,Var,~] = normfit(DiscPayoff);
